(function($) {
  var loaded = false,
  urlOnModalOpen = location.href,
  gettingMorePins = false,
  $container = null;
  
  $(function() {
    
    function isScrolledIntoView(elem) {
      var docViewTop = $(window).scrollTop();
      var docViewBottom = docViewTop + $(window).height();

      var elemTop = $(elem).offset().top;
      var elemBottom = elemTop + $(elem).height();

      return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop));
    }
    
    function get_pin(id) {
      $('#gt-pin-modal').modal('hide');
      
      $.get(
        GtPinboard.ajaxurl,
        {
            action : 'gt_pin-submit',
            postCommentNonce : GtPinboard.postCommentNonce,
            id: id
        },
        function( response ) {
          $(response).prependTo($("body"));
          
          $('#gt-pin-modal').on('hide', function() {
            $('#gt-pin-modal .gt-home-button').trigger('click');
          });

          $('#gt-pin-modal').on('shown', function() {
            $('#gt-pin-modal .modal-body').append($(".social-buttons:first").clone(true,true));
            
            $('#gt-pin-modal').append($('<a class="gt-home-button" href="'+urlOnModalOpen+'">Close</a>').hide());
            
            $('.gt-category-pins').each(function() {
              var $container = $(this);
              $container.imagesLoaded(function() {
                $container.masonry({
                  itemSelector: '.gt-category-pin',
                  columnWidth: ($container.data("columnWidth") || null)
                });
              });
            });
            
          });
          
          $('#gt-pin-modal').modal({
            keyboard: true,
            backdrop: true
          });
          
        }
      );
    }
    
    function getMorePins() {
      if(!gettingMorePins && isScrolledIntoView($(".infinite-scroll-indicator"))) {
        gettingMorePins = true;
        var data = $.extend($('.gt-pinboard').data(),{
          action : 'gt_pin-submit',
          postCommentNonce : GtPinboard.postCommentNonce,
          masonry: ""
        });
        var paged = (parseInt($('.gt-pinboard').data("paged"))||1)+1;
        
        data.paged = paged;
        $('.gt-pinboard').data("paged",paged);
        $.get(
          GtPinboard.ajaxurl, 
          data,
          function( response ) {
            $content = $(response);
            
            if($.trim(response)) {
              gettingMorePins = false;
              $container.append($content);
              $container.imagesLoaded(function() {
                $container.masonry({
                  itemSelector: '.gt-pin',
                  columnWidth: ($container.data("columnWidth") || null)
                });
              });
              
            } else {
              $(".infinite-scroll-indicator").remove();
            }
          }
        );
      }
    }
    
    $(window).bind("load", function() {
      $(window).bind("scroll resize", function() {
        getMorePins();
      });
      getMorePins();
    });
    
    $(window).bind("popstate", function () {
      if(loaded) {
        var parts = location.href.split("/");
        
        if($.inArray( "pins", parts ) > -1) {
          var slug = parts[parts.length-1] || parts[parts.length-2];
          get_pin(slug);
        } else {
          if($('#gt-pin-modal:visible').length) {
            $('#gt-pin-modal').modal('hide');
          } else {
            location.href = location.href;
          }
        }
        
      }
      loaded = true;
    });
    
    $('#gt-pin-modal .gt-home-button').live('click', function() {
      if(history.pushState) {
        history.pushState(null, document.title, this.href);
      }
      
      return false;
    });
    
    $('.gt-pinboard .gt-pin').live('click', function() {
      $(this).find('a').trigger('click');
    });
      
    $('.gt-pin a, .gt-in-content .gt-category-pin a').live('click', function() {
      
      if(history.pushState) {
        history.pushState(null, document.title, this.href);
      }
      
      
      //$(this).tooltip('hide');
      
      get_pin($(this).data("id"));
      
      return false;
    });
    
    // if($('.gt-pin a').tooltip) {
    //   $('.gt-pin a').tooltip();
    // }
    
    $(".modal-body .more").live('click', function() {
      location.reload();
      
      return false;
    });
    
    $(".gt-category-pins a").live('click',function() {
      
      $detailedPin = $(this).parents('.gt-full-pin');
      $detailedPin.find('h1').html($(this).data('title'));
      $detailedPin.find('figcaption').html($(this).data('caption'));
      $detailedPin.find('article').html($(this).data('body'));
      $detailedPin.find('figure img').attr('src',$(this).find('img').attr('src'));
      
      return false;
    });
    
    //$('.gt-pinboard').each(function() {
      $container = $('.gt-pinboard');
      $container.imagesLoaded(function() {
        $container.masonry({
          itemSelector: '.gt-pin',
          columnWidth: ($container.data("columnWidth") || null)
        });
      });
    //});
    
    $('.gt-category-pins').each(function() {
      var $container = $(this);
      $container.imagesLoaded(function() {
        $container.masonry({
          itemSelector: '.gt-category-pin',
          columnWidth: ($container.data("columnWidth") || null)
        });
      });
    });
    
  });
})(window.jQuery);